/*----------------------------------------------------------------------*
    smpl7.c
    Tv7 - Version 1.0
    [EEPROM]
    Copyright (C) 2006 BestTechnology CO.,LTD.
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  nCp[^[~i̒ʐM\tgɐڑĎgp܂B

  R\[œ͂f[^}CRɓꂽEEPROMɏ񂾂
  ǂݏo肵܂B
  ----------------------------------------------------------------------
 yڍׁz
  }CREEPROḾÄӂɏȂd؂Ăf[^͕ێ
  ܂̂ŁA쒆ɂ΂ΕύXKp̂p[^Ȃǂۑ
  Ă̂ɌĂ܂B

    EXe[^X
      eeprom_is_ready()
      result=1:ready, 0:not ready
    E҂
      eeprom_busy_wait()
    EoCg[h
      uint8_t eeprom_read_byte (const uint8_t *addr)
    E[h[h
      uint16_t eeprom_read_word (const uint16_t *addr)
    EubN[h
      void eeprom_read_block (void *buf, const void *addr, size_t n)
    EoCgCg
      void eeprom_write_byte (uint8_t *addr, uint8_t val)
    E[hCg
      void eeprom_write_word (uint16_t *addr, uint16_t val)
    EubNCg
      void eeprom_write_block (const void *buf, void *addr, size_t n)

 yӁz
  RAM̗lɃe|IɋɓxɕpɂȏsȂlȖړIEEPROM
  gp鎖͔ĉBpxōXVĂ܂ƁA[Je
  Ă鏑񐔂𒴂AXVłȂȂĂ܂܂B
  ܂avr-libEEPROM[`͈S݌v̂߂ݎԂv܂B
  傫ڂ̃f[^ލۂ͔z\̂ō\AubNR}h
  ANZX鎖߂܂B
  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O
#include <avr/pgmspace.h>   // 
#include <avr/eeprom.h>     // EEPROM֘A
#include <avr/interrupt.h>  // 荞݊֘A
#include <string.h>
#include <rs.h>             // USARTʐMCu

// EEPROMTCY
#define EEPROM_SIZE (E2END+1)

const char test[] = "0123456789ABCDEFabcdefghijklmnopqrstuvwxyz!?@+-/*\r";

/*-----------------------------------------------*/
/* EFCg[` (^C}/JE^2gp)     */
/*-----------------------------------------------*/
void wait (unsigned long pause_ms)
{
  unsigned long i;

  TCCR2A = 0x00;
  TCCR2B = 0x00;   // stop
  TCNT2  = 0;      // set count
  OCR2A  = 0xfa;   // set compare
  TCCR2A = 0x02;   // ctc
  TCCR2B = 0x04;   // start timer clk/64  (OCF=976.5625Hz1ms)

  for (i = 0; i < pause_ms; i++) {
    loop_until_bit_is_set(TIFR2, OCF2A);
    TIFR2 |= _BV(OCF2A);
  }
  TCCR2B = 0x00;   // stop
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void)
{
  unsigned short  i;
  char            c;
  unsigned char   d[100];

  // ʐM|[g {[[g115200[bps]
  rs_init(br115200);

  // Wo͂libm128.ã[`Ɋ蓖
  fdevopen(rs_putchar, rs_getchar);
  DDRB |= _BV(DDB0);  // PBo͂
  PORTB |= _BV(PB0);  // LEDOFF PB0=0
  // ʐM͊荞݂ŏ܂
  // ͕K荞݂ԂɂĂ
  sei();

  puts_P(PSTR("\n<SMPL7 start>"));

  printf_P(PSTR("MY EEPROM SIZE=%d"), EEPROM_SIZE);
  printf("\n>");
  
  while(1) {
    if(rs_rx_buff ()){
      c = rs_getc();
      switch(c) {
        // 
        case 'w':
        case 'W':
          puts_P(PSTR("\n[WRITE] After inputting the character string which you write, please push the entering key."));

          for(i = 0, c = 0; (i < EEPROM_SIZE) && (c != '\r'); i++) {
            while(!rs_rx_buff());
            rs_printf("%c",c = rs_getc());
            eeprom_busy_wait();
            eeprom_write_byte((uint8_t *)i, c);
          }
          break;

        // ubN
        case 'b':
        case 'B':
          puts_P(PSTR("\n[BLOCK WRITE]"));

          eeprom_busy_wait();
          eeprom_write_block(test, 0, strlen(test));
          break;

        // ǂݏo
        case 'r':
        case 'R':
          puts_P(PSTR("\n[READ]"));

          eeprom_busy_wait();
          for(i = 0, c = 0; (i < EEPROM_SIZE); i++) {
            c = eeprom_read_byte((uint8_t *)i);
            if((c != '\r') && (c != 0xff)) putchar(c);
            else break;
          }
          break;

        // ubNǂݍ
        case 'f':
        case 'F':
          printf_P(PSTR("\n[BLOCK READ] Block size=%d\n"), sizeof(d));

          eeprom_busy_wait();
          eeprom_read_block(&d, 0, sizeof(d));
          for(i = 0; i < sizeof(d); i++) {
            c = d[i];
            if((c != '\r') && (c != 0xff)) putchar(c);
            else break;
          }
          break;

        // S
        case 'e':
        case 'E':
          puts_P(PSTR("\n[ERASE] In the midst of elimination."));

          const unsigned char ND[128] = {
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
            0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
          };

          for(i = 0; i < (EEPROM_SIZE / sizeof(ND)); i++) {
            eeprom_busy_wait();
            eeprom_write_block(ND, (uint8_t *)(i * sizeof(ND)), sizeof(ND));
            putchar('*');
          }
          break;

        case '?':
          puts_P(
            PSTR(
              "\n COMMAND LIST\n"
              " w : byte write\n"
              " b : block write \n"
              " r : read all data\n"
              " f : block read\n"
              " e : erase all"
            )
          );
          break;

        // ̑
        default:
          puts_P(PSTR("\n*Command Error*"));
          break;
      }
      printf("\n>");
      rs_rx_purge();
    }
  }
}
